/*
	ゆるゆるナンプレ！ - the number place puzzle game.
	Copyright (C) 2009 asari
	
	This program is free software; you can redistribute it	 and/or modify it under the terms of the GNU General P	ublic License as published by the Free Software Founda	tion; either version 3 of the License, or (at your opt	ion) any later version.
	
	This program is distributed in the hope that it will b	e useful, but WITHOUT ANY WARRANTY; without even the i	mplied warranty of MERCHANTABILITY or FITNESS FOR A PA	RTICULAR PURPOSE. See the GNU General Public License f	or more details.
	
	You should have received a copy of the GNU General Pub	lic License along with this program. If not, see <http	://www.gnu.org/licenses/>.
*/

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <qmainwindow.h>
#include <qapplication.h>
#include <qpushbutton.h>
#include <qtextcodec.h>
#include <qfont.h>
#include <qmenubar.h>
#include <qpixmap.h>
#include <qpainter.h>
#include <qpicture.h>
#include <qpen.h>
#include <qstring.h>

#include <qfile.h>
#include <qtextstream.h>
#include <qvaluelist.h>

class Mainwindow : public QWidget{
	Q_OBJECT

public:
	Mainwindow(QWidget *parent = 0, const char *name = 0);

protected:
	void paintEvent( QPaintEvent * );
	void mousePressEvent( QMouseEvent *e );
	void mouseMoveEvent( QMouseEvent *e );
	void mouseReleaseEvent( QMouseEvent *e );

private:
	int mx, my;
	int mx_pre, my_pre;
	int index;
	int pen_size;

	int pre_box_x, pre_box_y;
	QString input, dir;
	int pre_input;
	int gameclear;

	int x;
	int y;
	int w;
	int v;

	QString window_title;
	QString quiz_file;

	int quiz[9][9];
	int sheet[9][9];

	QString word_input[100];
	int word_output[100];

	QTextCodec *codec;
	QPushButton *button;
	QMenuBar *menubar;
	QPixmap buffer, screen;
	QPen pen;

	void PaintSheet();
	void GameClear();
	int AnsCheck();
	void readMap();
	void readSetupMap();
	void save(int flag);
	void load();
	void startup();
	void save_cleaner();
	void main_screen();

private slots:
	void slot_load();
	void slot_restart();
	void slot_version();
	void slot_save_cleaner();
	void slot_quitgame();

};

#endif //MAINWINDOW_H